#!/usr/bin/perl -w

require WWW::Mechanize;

my $mech = WWW::Mechanize->new(agent => "perl-buggy/".$VERSION);

sub fetchByRef {
 my $refnum = shift;

 my $tb = {
           reference => $refnum,
           id => 0,
           url => "http://www.geocaching.com/track/details.aspx?tracker=".$refnum,
           name => "",
           owner => "",
           released => "",
           origin => "",
           holder => "",
           retrieved => 0,
           dropped => 0,
           grabbed => 0,
           discovered => 0,
           note => 0,
           mileage => 0,
           goal => "",
           about => "",
           type => "",
           icon => ""
          };

 $mech->get($tb->{url});
 $mech->submit_form(
                    form_name => "aspnetForm",
                    fields => {
                               __EVENTTARGET => "ctl00\$ContentBody\$TravelBugLog\$lnkViewAll",
                               __EVENTARGUMENT => ""
                              }
                   );
 my $content = $mech->content();

 $content =~ /<span id="ctl00_ContentBody_lbHeading">(.*?)<\/span>/gis;
 $tb->{name} = "<a href=\"".$tb->{url}."\">".$1."</a>";

 $content =~ /<img id="ctl00_ContentBody_BugDetails_BugTypeImage" src="(.*?)" alt="(.*?)"/gis;
 $tb->{icon} = "<img src=\"".$1."\" class=\"icon\" alt=\"".$2."\" />";
 $tb->{type} = $2;

 $content =~ /<a id="ctl00_ContentBody_BugDetails_BugOwner" title="Visit this user's profile" href="(.*?)">(.*?)<\/a>/gis;
 $tb->{owner} = "<a href=\"".$1."\">".$2."</a>";

 $content =~ /<strong>Released:<\/strong> (.*?)<\/span>/gis;
 $tb->{released} = $1;

 $content =~ /<strong>Origin<\/strong>: (.*?)<\/span>/gis;
 $tb->{origin} = $1;

 if ($content =~ /<a id="ctl00_ContentBody_BugDetails_BugLocation">In the hands of the owner.<\/a>/gis) {
  $tb->{holder} = $tb->{owner};
 } else {
  $content =~ /<a id="ctl00_ContentBody_BugDetails_BugLocation" title="Visit (user's profile|listing)" href="(.*?)">In (the hands of )?(.*?)<\/a>/gis;
  $tb->{holder} = "<a href=\"".$2."\">".$4."</a>";
 }

 $content =~ /<span id="ctl00_ContentBody_BugDetails_BugGoal">(.*?)<\/span>/gis;
 $tb->{goal} = $1;

 $content =~ /<span id="ctl00_ContentBody_BugDetails_BugDetails">(.*?)<\/span>/gis;
 $tb->{about} = $1;

 if ($content =~ /Tracking History \((\d*\.\d*)mi\)/gis) {
  $tb->{mileage} = $1;
 } else {
  $tb->{mileage} = 0;
 }

 while ($content =~ /<img src='\.\.\/images\/icons\/(picked_up|dropped_off|icon_discovered|icon_note|transfer)\.gif' width="16"/gis) {
  if ($1 eq "picked_up") {
   $tb->{retrieved}++;
  } elsif ($1 eq "dropped_off") {
   $tb->{dropped}++;
  } elsif ($1 eq "icon_discovered") {
   $tb->{discovered}++;
  } elsif ($1 eq "icon_note") {
   $tb->{note}++;
  } elsif ($1 eq "transfer") {
   $tb->{grabbed}++;
  }
 }

 return $tb;
}

1;
